/**
 * AsynchronousNode.java
 * Created on 2005/05/18
 * Copyright (c) by es , All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND 
 * CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED 
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY 
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF 
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package izayoi.node;

import java.io.IOException;
import java.net.MalformedURLException;
import java.net.ProtocolException;

/**
 * Node̔񓯊talkׂ̈I/F
 * @author es
 */
public interface AsynchronousNode extends Node {

    /**
     * Xi[ǉ.<br>
     * ̃m[h̃Cxg󂯎郊Xi[ǉ
     * @param listener 񓯊m[hXi
     */
    public void addNodeListener(AsynchronousNodeListener listener);
	/**
	 * #bye() ̔񓯊^
	 * @see bye()
	 */
	public void asyncBye();

	/**
	 * #get(java.lang.String, java.lang.String) ̔񓯊^
	 * @param filename t@C
	 * @param timeArgument w
	 * @see GenericNode#get(java.lang.String, java.lang.String)
	 */
	public void asyncGet(String filename, String timeArgument);

	/**
	 * #have(java.lang.String) ̔񓯊^
	 * @param filename t@C
	 * @see #have(java.lang.String)
	 */
	public void asyncHave(String filename);

	/**
	 * #head(java.lang.String, java.lang.String) ̔񓯊^
	 * @param filename t@C
	 * @param timeArgument w
	 * @see #head(java.lang.String, java.lang.String)
	 */
	public void asyncHead(String filename, String timeArgument);

	/**
	 * #join() ̔񓯊^
	 * @see #join()
	 */
	public void asyncJoin();

	/**
	 * #node() ̔񓯊^
	 * @see #node()
	 */
	public void asyncNode();

	/**
	 * #ping() ̔񓯊^
	 * @see #ping()
	 */
	public void asyncPing();

	/**
	 * #root() ̔񓯊^
	 * @see #root()
	 */
	public void asyncRoot();
 
    /**
     * 񓯊talks
     * @param command R}h
     * @param argument 
     * @throws MalformedURLException
     * @throws ProtocolException
     * @throws IOException
     */
    public void asyncTalk(String command, String argument) throws MalformedURLException, ProtocolException, IOException;

	/**
	 * #update() ̔񓯊^
	 * @param filename
	 * @param timeArgument
	 * @param md5
	 * @param nodeStr
	 * @see #update()
	 */
	public void asyncUpdate(String filename, String timeArgument, String md5, String nodeStr);

    /**
     * CxgXi[ɒʒm
     * @param event m[hCxg
     */
    public void fire(TalkingEvent event);
    
    /**
     * ݓo^Ă郊Xi[擾
     * @return
     */
    public AsynchronousNodeListener[] getNodeListeners();

    /**
     * Xi폜.<br>
     * w肳ꂽXi[폜
     * @param listener 񓯊m[hXi
     */
    public void removeNodeListener(AsynchronousNodeListener listener);

}
