/**
 * NodeAdapter.java
 * Created on 2005/05/23
 * Copyright (c) by es , All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND 
 * CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED 
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY 
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF 
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package izayoi.node;

/**
 * m[hCxgpAdapter
 * @author es
 */
public class NodeAdapter implements AsynchronousNodeListener {

    /* ( Javadoc)
     * @see izayoi.node.AsynchronousNodeListener#commFinished(izayoi.node.TalkingEvent)
     */
    public final void commFinished(TalkingEvent event) {
        String cmd = event.getCommand();
        if (cmd.equals("ping")) {
            ping(event);
        } else if (cmd.equals("join")) {
            join(event);
        } else if (cmd.equals("node")) {
            node(event);
        } else if (cmd.equals("bye")) {
            bye(event);
        } else if (cmd.equals("have")) {
            have(event);
        } else if (cmd.equals("get")) {
            get(event);
        } else if (cmd.equals("head")) {
            head(event);
        } else if (cmd.equals("update")) {
            update(event);
        } else if (cmd.equals("/")) {
            root(event);
        } else {
            unkownCommand(event);
        }
    }

    /**
     * /ping ̏I
     * @param event
     */
    public void ping(TalkingEvent event) {
    }

    /**
     * /join ̏I
     * @param event
     */
    public void join(TalkingEvent event) {
    }

    /**
     * /node ̏I
     * @param event
     */
    public void node(TalkingEvent event) {
    }

    /**
     * /bye ̏I
     * @param event
     */
    public void bye(TalkingEvent event) {
    }

    /**
     * /have ̏I
     * @param event
     */
    public void have(TalkingEvent event) {
    }

    /**
     * /get ̏I
     * @param event
     */
    public void get(TalkingEvent event) {
    }

    /**
     * /head ̏I
     * @param event
     */
    public void head(TalkingEvent event) {
    }

    /**
     * /update ̏I
     * @param event
     */
    public void update(TalkingEvent event) {
    }

    /**
     * / ̏I
     * @param event
     */
    public void root(TalkingEvent event) {
    }

    /**
     * ̖̑߂̏I
     * @param event
     */
    public void unkownCommand(TalkingEvent event) {
    }
}
