/**
 * TalkingEvent.java
 * Created on 2005/05/20
 * Copyright (c) by es , All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND 
 * CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED 
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY 
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF 
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package izayoi.node;

import java.util.EventObject;

/**
 * m[hCxg
 * @author es
 */
public class TalkingEvent extends EventObject {

    protected NegateResponse neg;
    protected String argument;
    protected String command;
    protected String[] response;
    protected boolean result;


    /**
     * @param src
     */
    private TalkingEvent(Object src) {
        super(src == null ? new Object() : src);
    }

    public TalkingEvent(AsynchronousNode src, String command, String argument, NegateResponse err) {
        this(src);
        this.neg = err;
        this.argument = argument;
        this.command = command;
        this.response = err.getQuery().getResponse();
        this.result = false;
    }

    public TalkingEvent(AsynchronousNode src, String command, String argument, String[] resp) {
        this(src);
        this.neg = null;
        this.argument = argument;
        this.command = command;
        this.response = resp;
        this.result = true;
    }

    /**
     * m[hɔs
     * @return
     */
    public String getArgument() {
        return argument;
    }

    /**
     * m[hɔsR}h
     * @return
     */
    public String getCommand() {
        return command;
    }

    /**
     * m[h̉.
     * @return 
     */
    public String[] getResponse() {
        return response;
    }

    /**
     * ʐM
     * @return nȂ^
     */
    public boolean getResult() {
        return result;
    }

    /**
     * Cxg̔m[h
     * @return
     */
    public AsynchronousNode getSourceNode() {
        if(source instanceof AsynchronousNode) {
            return (AsynchronousNode) source;
        } else {
            return null;
        }
    }

    /**
     * ے艞̏ڍ
     * @return ے艞(m艞ꍇnull)
     */
    public NegateResponse getNegateDetail() {
        return neg;
    }

    /* ( Javadoc)
     * @see java.util.EventObject#getSource()
     */
    public Object getSource() {
        return getSourceNode();
    }

}
